import React from 'react'
import Revalidation from '../src/'
import { render } from 'react-dom'

const SubmitForm = ({
  reValidation: { form, validate, valid, errors, validateAll },
  onSubmit
  }) =>
  <form>
    <div className="formGroup">
      <label>Name</label>
      <input
        type="text"
        value={form.name}
        onChange={e => validate('name', e.target.value)}
      />
      {errors.name}
    </div>
    <p>{valid.toString()}</p>
    <button onClick={() => validateAll(onSubmit)}>Submit</button>
  </form>

const isGreaterThan = a => b => b > a
const ErrorComponent = ({ errorMsgs }) =>
  <div className="error">{errorMsgs.shift()}</div>
const validationRules = {
  name: [[isGreaterThan(5), `Minimum Name length of 6 is required.`]]
}
const initialState = { name: 'Alex' }
const enhanced = Revalidation(initialState, validationRules, ErrorComponent, {
  validateSingle: false
})
const EnhancedSubmitForm = enhanced(SubmitForm)

class SubmitPage extends React.Component<any, any> {
  constructor(props) {
    super(props)
    this.state = { form: { name: 'Alex' } }
    this.onSubmit = this.onSubmit.bind(this)
    console.log('ok!')
  }
  onSubmit(values) {
    console.log('action', values);
    alert('submitted')
  }
  render() {
    console.log('rendering...')
    return (
      <EnhancedSubmitForm onSubmit={(x) => console.log(x)} form={this.state.form} />
    )
  }
}

export default SubmitPage
